
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Item_redemptionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const item_redemptions = await db.item_redemptions.create(
            {
                id: data.id || undefined,
        
        redeemed_at: data.redeemed_at
        ||
        null
            ,
            
        cost_doodlecoins: data.cost_doodlecoins
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        note: data.note
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await item_redemptions.setUser( data.user || null, {
            transaction,
        });
        
        await item_redemptions.setShop_item( data.shop_item || null, {
            transaction,
        });
        

        

        

        return item_redemptions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const item_redemptionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                redeemed_at: item.redeemed_at
            ||
            null
            ,
            
                cost_doodlecoins: item.cost_doodlecoins
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                note: item.note
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const item_redemptions = await db.item_redemptions.bulkCreate(item_redemptionsData, { transaction });

        // For each item created, replace relation files
        

        return item_redemptions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const item_redemptions = await db.item_redemptions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.redeemed_at !== undefined) updatePayload.redeemed_at = data.redeemed_at;
        
        
        if (data.cost_doodlecoins !== undefined) updatePayload.cost_doodlecoins = data.cost_doodlecoins;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.note !== undefined) updatePayload.note = data.note;
        
        
        updatePayload.updatedById = currentUser.id;

        await item_redemptions.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await item_redemptions.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.shop_item !== undefined) {
            await item_redemptions.setShop_item(
              
              data.shop_item,
              
              { transaction }
            );
        }
        

        
        

        

        return item_redemptions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const item_redemptions = await db.item_redemptions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of item_redemptions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of item_redemptions) {
                await record.destroy({transaction});
            }
        });


        return item_redemptions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const item_redemptions = await db.item_redemptions.findByPk(id, options);

        await item_redemptions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await item_redemptions.destroy({
            transaction
        });

        return item_redemptions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const item_redemptions = await db.item_redemptions.findOne(
            { where },
            { transaction },
        );

        if (!item_redemptions) {
            return item_redemptions;
        }

        const output = item_redemptions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await item_redemptions.getUser({
            transaction
        });
        
        
        output.shop_item = await item_redemptions.getShop_item({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.shop_items,
        as: 'shop_item',
        
        where: filter.shop_item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.shop_item.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.shop_item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.note) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'item_redemptions',
                        'note',
                        filter.note,
                    ),
                };
            }
            

            
            

            
            if (filter.redeemed_atRange) {
                const [start, end] = filter.redeemed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    redeemed_at: {
                    ...where.redeemed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    redeemed_at: {
                    ...where.redeemed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.cost_doodlecoinsRange) {
                const [start, end] = filter.cost_doodlecoinsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    cost_doodlecoins: {
                    ...where.cost_doodlecoins,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    cost_doodlecoins: {
                    ...where.cost_doodlecoins,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.item_redemptions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'item_redemptions',
                        'status',
                        query,
                    ),
                ],
            };
        }

        const records = await db.item_redemptions.findAll({
            attributes: [ 'id', 'status' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['status', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.status,
        }));
    }

    
};

